/*
 * Copyright (C) 2020 CERN (www.cern.ch)
 *
 * Author: Miguel Jimenez Lopez <miguel.jimenez@sevensols.com>
 *
 * Released to the public domain as sample code to be customized.
 *
 * This work is part of the White Rabbit project, a research effort led
 * by CERN, the European Institute for Nuclear Research.
 */

#ifndef __LOG_DEVICE_H__
#define __LOG_DEVICE_H__

typedef struct log_device_iface * log_device_interface;
struct log_dev {
	log_device_interface ops;
	void *private;
};
typedef struct log_dev * log_device;

struct log_device_iface {
	void (*init_log_device)(log_device dev);
	void (*send_to_log_device)(log_device dev, const char *msg);
	void (*deinit_log_device)(log_device dev);
	void (*clear_log_device)(log_device dev);
};

log_device create_log_device(void *args, log_device_interface interface);
void send_to_log_device(log_device dev, const char *msg);
void clear_log_device(log_device dev);
void destroy_log_device(log_device dev);

#endif
