/*
 * Copyright (C) 2020 CERN (www.cern.ch)
 *
 * Author: Miguel Jimenez Lopez <miguel.jimenez@sevensols.com>
 *
 * Released to the public domain as sample code to be customized.
 *
 * This work is part of the White Rabbit project, a research effort led
 * by CERN, the European Institute for Nuclear Research.
 */

#ifndef __STATS_ENGINE_H__
#define __STATS_ENGINE_H__

#include "log-device.h"
#include "usr-timestamp.h"

typedef struct _stats_engine *stats_engine;

stats_engine create_stats_engine(void);
int check_stats_engine(stats_engine engine);
void attach_log_devices_to_stats_engine(stats_engine engine,
					log_device *log_devs,
					unsigned int n_log_devs);
int enable_log_for_stats_engine(stats_engine engine);
int disable_log_for_stats_engine(stats_engine engine);
int add_usr_timestamp_to_stats_engine(stats_engine engine,
				struct usr_timestamp *ts);
int run_stats_engine(stats_engine engine, int verbose);
void destroy_stats_engine(stats_engine engine);

#endif
