#ifndef __WBGEN2_REGDEFS_WR_DIO
#define __WBGEN2_REGDEFS_WR_DIO

#ifdef __KERNEL__
#include <linux/types.h>
#else
#include <stdint.h>
#endif


#if defined( __GNUC__)
#define PACKED __attribute__ ((packed))
#else
#error "Unsupported compiler?"
#endif

struct regmap {
	int trig_l;
	int trig_h;
	int cycle;
	int pulse;
	int pulse_per;
	int fifo_tai_l;
	int fifo_tai_h;
	int fifo_cycle;
	int fifo_leap_second;
	int fifo_status;
};

struct regmap_common {
	int ver_;
	int iomode_reg;
	int latch_reg;
	int trig_reg;
	int pulse_reg;
	int eic_idr_reg;
	int eic_ier_reg;
	int eic_imr_reg;
	int eic_isr_reg;
};

extern struct regmap regmap_v1[];
extern struct regmap regmap_v2[];

extern struct regmap_common regmap_common_v1;
extern struct regmap_common regmap_common_v2;

#define WBGEN2_GEN_MASK(offset, size) (((1<<(size))-1) << (offset))

/* definitions for field: dio fifo not-empty 0 in reg: Interrupt status register */
#define DIO_EIC_ISR_NEMPTY_0                  WBGEN2_GEN_MASK(0, 1)

/* definitions for field: dio fifo not-empty 1 in reg: Interrupt status register */
#define DIO_EIC_ISR_NEMPTY_1                  WBGEN2_GEN_MASK(1, 1)

/* definitions for field: dio fifo not-empty 2 in reg: Interrupt status register */
#define DIO_EIC_ISR_NEMPTY_2                  WBGEN2_GEN_MASK(2, 1)

/* definitions for field: dio fifo not-empty 3 in reg: Interrupt status register */
#define DIO_EIC_ISR_NEMPTY_3                  WBGEN2_GEN_MASK(3, 1)

/* definitions for field: dio fifo not-empty 4 in reg: Interrupt status register */
#define DIO_EIC_ISR_NEMPTY_4                  WBGEN2_GEN_MASK(4, 1)

/* definitions for field: dio fifo not-empty 5 in reg: Interrupt status register */
#define DIO_EIC_ISR_NEMPTY_5                  WBGEN2_GEN_MASK(5, 1)

/* definitions for field: LeapSecond value in reg: FIFO 'Timestamp FIFO 2' data output register 3 */
#define DIO_TSF_R3_LEAP_SECOND_VALUE_MASK    WBGEN2_GEN_MASK(0, 16)

/* definitions for field: LeapSecond valid in reg: FIFO 'Timestamp FIFO 2' data output register 3 */
#define DIO_TSF_R3_LEAP_SECOND_VALID         WBGEN2_GEN_MASK(18, 1)
#define DIO_TSF_R3_LEAP_SECOND_VALID_SHIFT	 18

/* definitions for field: LeapSecond flag 59 in reg: FIFO 'Timestamp FIFO 2' data output register 3 */
#define DIO_TSF_R3_LEAP_SECOND_FLAG_59       WBGEN2_GEN_MASK(16, 1)
#define DIO_TSF_R3_LEAP_SECOND_FLAG_59_SHIFT 16

/* definitions for field: LeapSecond flag 61 in reg: FIFO 'Timestamp FIFO 2' data output register 3 */
#define DIO_TSF_R3_LEAP_SECOND_FLAG_61       WBGEN2_GEN_MASK(17, 1)
#define DIO_TSF_R3_LEAP_SECOND_FLAG_61_SHIFT 17

struct regmap_common get_regmap_common(unsigned int ver);
struct regmap *get_regmap(unsigned int ver);

#endif