#include "wr-dio-regs_v1.h"
#include "wr-dio-regs.h"

#define R(x) (offsetof(struct DIO_WB, x))
struct regmap regmap_v1[] = {
	{
		.trig_l = R(TRIG0),
		.trig_h = R(TRIGH0),
		.cycle = R(CYC0),
		.pulse = R(PROG0_PULSE),
		.pulse_per = 0,
		.fifo_tai_l = R(TSF0_R0),
		.fifo_tai_h = R(TSF0_R1),
		.fifo_cycle = R(TSF0_R2),
		.fifo_leap_second = 0,
		.fifo_status = R(TSF0_CSR),
	}, {
		.trig_l = R(TRIG1),
		.trig_h = R(TRIGH1),
		.cycle = R(CYC1),
		.pulse = R(PROG1_PULSE),
		.pulse_per = 0,
		.fifo_tai_l = R(TSF1_R0),
		.fifo_tai_h = R(TSF1_R1),
		.fifo_cycle = R(TSF1_R2),
		.fifo_leap_second = 0,
		.fifo_status = R(TSF1_CSR),
	}, {
		.trig_l = R(TRIG2),
		.trig_h = R(TRIGH2),
		.cycle = R(CYC2),
		.pulse = R(PROG2_PULSE),
		.pulse_per = 0,
		.fifo_tai_l = R(TSF2_R0),
		.fifo_tai_h = R(TSF2_R1),
		.fifo_cycle = R(TSF2_R2),
		.fifo_leap_second = 0,
		.fifo_status = R(TSF2_CSR),
	}, {
		.trig_l = R(TRIG3),
		.trig_h = R(TRIGH3),
		.cycle = R(CYC3),
		.pulse = R(PROG3_PULSE),
		.pulse_per = 0,
		.fifo_tai_l = R(TSF3_R0),
		.fifo_tai_h = R(TSF3_R1),
		.fifo_cycle = R(TSF3_R2),
		.fifo_leap_second = 0,
		.fifo_status = R(TSF3_CSR),
	}, {
		.trig_l = R(TRIG4),
		.trig_h = R(TRIGH4),
		.cycle = R(CYC4),
		.pulse = R(PROG4_PULSE),
		.pulse_per = 0,
		.fifo_tai_l = R(TSF4_R0),
		.fifo_tai_h = R(TSF4_R1),
		.fifo_cycle = R(TSF4_R2),
		.fifo_leap_second = 0,
		.fifo_status = R(TSF4_CSR),
	}, {
		.trig_l = 0,
		.trig_h = 0,
		.cycle = 0,
		.pulse = 0,
		.pulse_per = 0,
		.fifo_tai_l = 0,
		.fifo_tai_h = 0,
		.fifo_cycle = 0,
		.fifo_leap_second = 0,
		.fifo_status = 0,
	}
};

struct regmap_common regmap_common_v1 = 
{
	.ver_ = 0,
	.iomode_reg = R(IOMODE),
	.latch_reg = R(R_LATCH),
	.trig_reg = R(TRIG),
	.pulse_reg = R(PULSE),
	.eic_idr_reg = R(EIC_IDR),
	.eic_ier_reg = R(EIC_IER), 
	.eic_imr_reg = R(EIC_IMR),
	.eic_isr_reg = R(EIC_ISR),
};
